#include "internal.h"
#include <stddef.h>

static struct jfaud_init_params *params = NULL;


#define FIXSHIFT 8
jfauderr jfaudfx_audiolib(jfaud_buffer *buf)
{
	jfauderr err;
	unsigned long rateratio, destlen, i, j;

	jfaud_buffer dst;
	unsigned short *wptrs, *wptrd;
	unsigned char  *bptrs, *bptrd;

	if (!params) params = jfaud_getparams();

	if (buf->bitspersample != 8 && buf->bitspersample != 16) return jfauderr_genericerror;
	if (buf->samplerate >= params->samplerate) return jfauderr_ok;	// we don't downsample

	rateratio = (params->samplerate << FIXSHIFT) / buf->samplerate;
	destlen = ((buf->numsamples * rateratio) >> FIXSHIFT);
	rateratio = (buf->samplerate << FIXSHIFT) / params->samplerate;

	if ((err = jfaudbuffer_alloc(&dst, params->samplerate, buf->channels, buf->bitspersample, destlen)) != jfauderr_ok)
		return jfauderr_outofmemory;

	destlen *= buf->channels;

	if (buf->bitspersample == 8) {
		bptrs = (unsigned char *)buf->data;
		bptrd = (unsigned char *)dst.data;
		for (i=j=0; j < destlen; i+=rateratio,j++)
			bptrd[j] = bptrs[i>>FIXSHIFT];
	} else {
		wptrs = (unsigned short *)buf->data;
		wptrd = (unsigned short *)dst.data;
		for (i=j=0; j < destlen; i+=rateratio,j++)
			wptrd[j] = wptrs[i>>FIXSHIFT];
	}

	jfaudbuffer_free(buf);
	memcpy(buf, &dst, sizeof(dst));

	return jfauderr_ok;
}
